#ifndef _Xrmcommandline_h
#define _Xrmcommandline_h

#include <X11/Xresource.h>

static XrmOptionDescRec options[] = {
//  For these options, try to use '+' to turn them on, and '-' to turn them
//    off, even though this is different from the usual tradition of -foo
//    turning on 'foo', which is off by default.  At least this way,
//    it is self-consistent, and self-explanatory.

//  General, X11 resources:
{ (char*)"-display", (char*)"*display", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-font", (char*)"*font", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-title", (char*)"*title", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-geometry", (char*)"*geometry", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-hmargin", (char*)"*horizontalMargin", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-vmargin", (char*)"*verticalMargin", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-vspacing", (char*)"*verticalSpacing", XrmoptionSepArg, (caddr_t) NULL },


//  XOSView-specific resources:
{ (char*)"-labels", (char*)"*labels", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+labels", (char*)"*labels", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-captions", (char*)"*captions", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+captions", (char*)"*captions", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-usedlabels", (char*)"*usedlabels", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+usedlabels", (char*)"*usedlabels", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-samplesPerSec", (char*)"*samplesPerSec", XrmoptionSepArg, (caddr_t) NULL },
//  CPU resources
{ (char*)"-cpu", (char*)"*cpu", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+cpu", (char*)"*cpu", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"+cpus", (char*)"*cpuFormat", XrmoptionNoArg, (XPointer)"all" },
// Load resources
{ (char*)"-load", (char*)"*load", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+load", (char*)"*load", XrmoptionNoArg, (XPointer)"True" },
// Memmeter resources
{ (char*)"-mem", (char*)"*mem", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+mem", (char*)"*mem", XrmoptionNoArg, (XPointer)"True" },
// Swapmeter resources
{ (char*)"-swap", (char*)"*swap", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+swap", (char*)"*swap", XrmoptionNoArg, (XPointer)"True" },
// Batterymeter resources
{ (char*)"-battery", (char*)"*battery", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+battery", (char*)"*battery", XrmoptionNoArg, (XPointer)"True" },
// Wirelessmeter resources
{ (char*)"-wireless", (char*)"*wireless", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+wireless", (char*)"*wireless", XrmoptionNoArg, (XPointer)"True" },
//  GFX resources
{ (char*)"-gfx", (char*)"*gfx", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+gfx", (char*)"*gfx", XrmoptionNoArg, (XPointer)"True" },

// Networkmeter resources
{ (char*)"-net", (char*)"*net", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+net", (char*)"*net", XrmoptionNoArg, (XPointer)"True" },
//  Previously, network was overloaded to be the bandwidth and the
//  on/off flag.  Now, we have -net for on/off, and networkBandwidth
//  for bandwidth, with the alias networkBW, and network for backwards
//  compatibility.
{ (char*)"-network", (char*)"*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-networkBW", (char*)"*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },
{ (char*)"-networkBandwidth", (char*)"*netBandwidth", XrmoptionSepArg, (caddr_t) NULL },

// Page Meter
{ (char*)"-page", (char*)"*page", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+page", (char*)"*page", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-pagespeed", (char*)"*pageBandWidth", XrmoptionSepArg, (caddr_t) NULL },

#if !defined(__hpux__) && !defined(__hpux)
//  Disk Meter Options
{ (char*)"-disk", (char*)"*disk", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+disk", (char*)"*disk", XrmoptionNoArg, (XPointer)"True" },
#endif

// Interrupt meter resources  --  all sorts of aliases.
{ (char*)"-int", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+int", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-ints", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+ints", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-interrupts", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+interrupts", (char*)"*interrupts", XrmoptionNoArg, (XPointer)"True" },

// Intrate meter resources, for platforms that support it.
{ (char*)"-irqrate", (char*)"*irqrate", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+irqrate", (char*)"*irqrate", XrmoptionNoArg, (XPointer)"True" },
{ (char*)"-intrate", (char*)"*irqrate", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+intrate", (char*)"*irqrate", XrmoptionNoArg, (XPointer)"True" },

// lmstemp resources
{ (char*)"-lmstemp", (char*)"*lmstemp", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+lmstemp", (char*)"*lmstemp", XrmoptionNoArg, (XPointer)"True" },
// coretemp resources
{ (char*)"-coretemp", (char*)"*coretemp", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+coretemp", (char*)"*coretemp", XrmoptionNoArg, (XPointer)"True" },
// acpitemp resources
{ (char*)"-acpitemp", (char*)"*acpitemp", XrmoptionNoArg, (XPointer)"False" },
{ (char*)"+acpitemp", (char*)"*acpitemp", XrmoptionNoArg, (XPointer)"True" },

//  Special, catch-all option here --
//    xosview -xrm (char*)"*memFreeColor: purple" should work, for example.
{ (char*)"-xrm", (char*)"*xrm", XrmoptionResArg, (caddr_t) NULL },
};
//  This auto-detects changes in the number of options.
static const int NUM_OPTIONS = sizeof(options) / sizeof(options[0]);

#endif
